require "faraday"
require "json"

module Gifster
  class Client
    BASE_URL = "http://api.giphy.com"

    attr_reader :connection, :api_key

    def initialize(api_key)
      @connection = Faraday.new(BASE_URL)
      @api_key = api_key
    end

    def search(query, limit, offset)
      response = connection.get do |req|
        req.url "/v1/gifs/search"
        req.headers["Accepts"] = "application/json"
        req.params['api_key'] = api_key
        req.params['q'] = query
        req.params['limit'] = limit
        req.params['offset'] = offset
      end
      JSON.parse(response.body)["data"]
    end

    def trending(limit, offset)
      response = connection.get do |req|
        req.url "/v1/gifs/trending"
        req.headers["Accepts"] = "application/json"
        req.params['api_key'] = api_key
        req.params['offset'] = offset
      end
      JSON.parse(response.body)["data"]
    end
  end
end